#ifndef TYPETRAITS_TO_UNDERLYING_H__
#define TYPETRAITS_TO_UNDERLYING_H__

#include <type_traits>

namespace TypeTraits
{

// This is a method that should appear in a forthcoming version of the standard.
// See http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2019/p1682r0.html

template <typename T, typename = std::enable_if_t<std::is_enum_v<T>> >
constexpr auto to_underlying(T v) noexcept
{
    return static_cast< std::underlying_type_t<T> >(v);
}

} // namespace TypeTraits

#endif // TYPETRAITS_TO_UNDERLYING_H__
