get_property(isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if(isMultiConfig)
    if(NOT "DebugWithAddressSanitizer" IN_LIST CMAKE_CONFIGURATION_TYPES)
        list(APPEND CMAKE_CONFIGURATION_TYPES DebugWithAddressSanitizer)
    endif()
else()
    set(allowableBuildTypes Debug Release RelWithDebInfo MinSizeRel   DebugWithAddressSanitizer)
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "${allowableBuildTypes}")
    if(NOT CMAKE_BUILD_TYPE)
        if(NOT CMAKE_CROSSCOMPILING)
            set(CMAKE_BUILD_TYPE Debug CACHE STRING "" FORCE)
        elseif()
            set(CMAKE_BUILD_TYPE Release CACHE STRING "" FORCE)
        endif()
    elseif(NOT CMAKE_BUILD_TYPE IN_LIST allowableBuildTypes)
        message(FATAL_ERROR "Invalid build type: ${CMAKE_BUILD_TYPE}")
    endif()
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES Clang)
    set(STATIC_LIBASAN "-static-libsan")
    set(STATIC_LIBTSAN "-static-libsan")
else()
    set(STATIC_LIBASAN "-static-libasan")
    set(STATIC_LIBTSAN "-static-libtsan")
endif()

# DebugWithAddressSanitizer
set(CMAKE_C_FLAGS_DEBUGWITHADDRESSSANITIZER "${CMAKE_C_FLAGS_DEBUG}" CACHE STRING "" FORCE)
set(CMAKE_CXX_FLAGS_DEBUGWITHADDRESSSANITIZER "${CMAKE_CXX_FLAGS_DEBUG} -fsanitize=address ${STATIC_LIBASAN}" CACHE STRING "" FORCE)
set(CMAKE_EXE_LINKER_FLAGS_DEBUGWITHADDRESSSANITIZER "${CMAKE_EXE_LINKER_FLAGS_DEBUG} -fsanitize=address ${STATIC_LIBASAN}" CACHE STRING "" FORCE)
set(CMAKE_SHARED_LINKER_FLAGS_DEBUGWITHADDRESSSANITIZER "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} -fsanitize=address ${STATIC_LIBASAN}" CACHE STRING "" FORCE)
set(CMAKE_STATIC_LINKER_FLAGS_DEBUGWITHADDRESSSANITIZER "${CMAKE_STATIC_LINKER_FLAGS_DEBUG}" CACHE STRING "" FORCE)
set(CMAKE_MODULE_LINKER_FLAGS_DEBUGWITHADDRESSSANITIZER "${CMAKE_MODULE_LINKER_FLAGS_DEBUG}" CACHE STRING "" FORCE)
